﻿SpeakinSpell = LibStub("AceAddon-3.0"):NewAddon("SpeakinSpell", "AceConsole-3.0", "AceEvent-3.0")

-------------------------------------------------------------------------------
-- CONSTANTS
-------------------------------------------------------------------------------


local MAX_MESSAGES_PER_SPELL = 50


-------------------------------------------------------------------------------
-- DEFAULT OPTIONS
-------------------------------------------------------------------------------


local DEFAULT_DATA_PER_CLASS = {

-------------------------------------------------------------------------------
["MAGE"] = {

	["ritual of refreshment"] = {
		Channels = {
			BG		= "SAY",
			Raid	= "SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Ritual of Refreshment is being placed near <player> please click to assist",
			[2] = "C1ick 4 t@b1e",
			[3] = "Magic Biscuits, Brownies, and Goo-balls $5. CDs $10. T-shirts $15. Enjoy the concert!",
			[4] = "<player>'s Magical Biscuits<TM> - WARNING: may cause nauseu, loss of appetite, blindness, fear, stunlock, or spontaneous transmutation into a sheep, pig, or turtle. Consult your doctor before eating <player>'s Magical Biscuits<TM>",
			[5] = "<player>'s Magical Biscuits<TM> - Now with 30% more Flavor Power!",
			[6] = "<player>'s Magical Biscuits<TM> - Try all new Organic <player>'s Magical Biscuits<TM>! Now in Teriaki Tofu Flavor!",
			[7] = "<player>'s Magical Biscuits<TM> - It's Mannabiscuitalisious<TM>!!",
			[8] = "<player>'s Magical Biscuits<TM> - Now with +35 Stamina Buff!! (also-gives-minus-thirty-five-stamina-debuff-no-actual-buff-may-be-visible-consult-your-doctor-before-eating <player>'s Magical Biscuits<TM>",
			[9] = "<player>'s Magical Biscuits<TM> - The Official Cereal of Beauty and the Beast VII (sings) Be... a... pest! Be a pest! Put my patience to the test! RENT IT TODAY!",
		},
	},
	["polymorph"] = { -- if unspecified rank, this means sheep (or may be glyphed to penguin)
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "PARTY",
			Solo	= nil, --"SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Sheeping <target>",
			[2] = "<player> is casting polymorph on <target>",
			[3] = "<target> is getting in touch with his inner spirit animal",
			[4] = "Bah, <target>",
		},
	},
	["ice block"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Is it cold in here, or is it just me?",
			[2] = "I am INVINCIBLE!",
			[3] = "Ice, ice, baby!",
			[4] = "Wonder Twin power activate! Form of an ice cube.",
			[5] = "HELP! I got trapped in a walk-in freezer.",
			[6] = "Oops, I think I stepped in the hunter's ice trap.",
		},
	},
	["invisibility"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Now you see me, soon you won't",
		},
	},
	["summon water elemental"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Yes, I AM a God!",
			[2] = "Let me introduce you to my little friend.",
		},
	},
	-- alliance portals
	["portal: ironforge"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Ironforge when we can summon Ironforge to us? Click to summon the city.",
			[3] = "Ironforge? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Ironforge, not the middle of the ocean, Ironforge...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Next stop: Ironforge. Home to all things great and small.",
		},
	},
	["portal: stormwind"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Stormwind when we can summon Stormwind to us? Click to summon the city.",
			[3] = "Stormwind? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Stormwind, not the middle of the ocean, Stormwind...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Next stop: Stormwind. Watch your step, don't fall into the canals. The sharks might get you.",
		},
	},
	["portal: darnassus"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Stormwind when we can summon Stormwind to us? Click to summon the city.",
			[3] = "Stormwind? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Stormwind, not the middle of the ocean, Stormwind...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Next stop: Darnassus, where you can hear the crickets.",
		},
	},
	["portal: exodar"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Stormwind when we can summon Stormwind to us? Click to summon the city.",
			[3] = "Stormwind? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Stormwind, not the middle of the ocean, Stormwind...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Entering this portal will take you to the ends of the earth... I mean Exodar.",
		},
	},
	["portal: theramore"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Stormwind when we can summon Stormwind to us? Click to summon the city.",
			[3] = "Stormwind? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Stormwind, not the middle of the ocean, Stormwind...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Tell Jaina I said hi",
		},
	},
	-- horde portals
	["portal: orgrimmar"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Orgrimmar when we can summon Orgrimmar to us? Click to summon the city.",
			[3] = "Orgrimmar? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Orgrimmar, not the middle of the ocean, Orgrimmar...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "WARNING: you might want to plug your nose before entering this portal. It smells like Orc where you're going.",
		},
	},
	["portal: thunder bluff"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Ironforge when we can summon Ironforge to us? Click to summon the city.",
			[3] = "Ironforge? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Ironforge, not the middle of the ocean, Ironforge...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Now entering Thunder Bluff, where no one can hear you scream, probably because there's nobody else there",
		},
	},
	["portal: undercity"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Undercity when we can summon Undercity to us? Click to summon the city.",
			[3] = "Undercity? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Undercity, not the middle of the ocean, Undercity...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Opening a portal to Sewerville",
		},
	},
	["portal: silvermoon"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Silvermoon when we can summon Silvermoon to us? Click to summon the city.",
			[3] = "Silvermoon? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Silvermoon, not the middle of the ocean, Silvermoon...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Next stop: Silvermoon, where mailboxes outnumber even the blood elves",
		},
	},
	["portal: stonard"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Ironforge when we can summon Ironforge to us? Click to summon the city.",
			[3] = "Ironforge? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Ironforge, not the middle of the ocean, Ironforge...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Opening a portal to Stonard. Grab me a phat herb bag full of merry mana pot while you're there, eh?",
		},
	},
	-- neutral portals
	["portal: shattrath"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Shattrath when we can summon Shattrath to us? Click to summon the city.",
			[3] = "Shattrath? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Shattrath, not the middle of the ocean, Shattrath...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "So people still visit Shattrath, huh?",
		},
	},
	["portal: dalaran"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			-- general portal messages
			[1] = "Entering this portal will take you to a far away city.",
			[2] = "Why go to Shattrath when we can summon Shattrath to us? Click to summon the city.",
			[3] = "Shattrath? Really? Why would you want to go there? Honestly, do you know who LIVES there??",
			[4] = "Focus <player>, they want to go to Shattrath, not the middle of the ocean, Shattrath...",
			[5] = "DISCLAIMER: I got my portal license off the AH. Use at your own risk.",
			[6] = "Unscheduled off world activation!",
			[7] = "Here's your portal. That'll be 2500g please. Hey the reagent isn't cheap... oh wait, yes it is, nevermind.",
			-- city-specific
			[8] = "Dalaran: it's not just for mages anymore",
		},
	},
},

-------------------------------------------------------------------------------
["HUNTER"] = {

	["call pet"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= "SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Heeere fido! Here boy! Come!",
			[2] = "Don't worry, he's friendly",
			[3] = "OK my pet's out now, so either he'll tank for us, or randomly pull aggro from a dozen mobs, we'll see...",
		},
	},
	["misdirect"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "No, no, go for <target>, he's the one biting your ankles!",
			[2] = "<target> insulted your mother, you gonna take that??",
			[3] = "<target> did it!",
		},
	},
	["feign death"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "I'm not quite dead yet",
			[2] = "Look ma, no health bar!",
			[3] = "Darn, I'm dead. No really!",
		},
	},
},

-------------------------------------------------------------------------------
["PRIEST"] = {

	["resurrection"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Rezzing <target>",
			[2] = "<target>, don't go into the light, return to the land of the living!",
			[3] = "Rise, <target>, and live again!",
			[4] = "Get yer lazy bones up!",
		},
	},
	["desperate prayer"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Help me, Lord!",
			[2] = "Dear Lord, I promise to be a better priest if you help <target> live another day.",
		},
	},
},

-------------------------------------------------------------------------------
["PALADIN"] = {

	["redemption"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Rezzing <target>",
			[2] = "<target>, don't go into the light, return to the land of the living!",
			[3] = "Rise, <target>, and live again!",
			[4] = "Get yer lazy bones up!",
		},
	},
	["divine intervention"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "It's a wipe! <target> has a DI.",
			[2] = "DI is short for DIE in a good place, somewhere <target> will be able to rez you.",
		},
	},
	["exorcism"] = {
		Channels = {
			BG		= nil, --"BATTLEGROUND",
			Raid	= nil, --"RAID",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "The power of CHRIST compels you!",
		},
	},
	["divine favor"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Dear Lord, I need a favor",
			[2] = "Dear Lord, remember that one time I went to church back in '83? I need you to return the favor",
		},
	},
	["lay on hands"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= "SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "I don't want anybody else, when I think about you, I touch your self",
			[2] = "Don't ask me how I laid my hands on you from way over here, but I just did",
		},
	},
	["hand of salvation"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= "EMOTE",
			Party	= "EMOTE",
			Solo	= "EMOTE",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "rubs down <target> releasing some of the threat.",
			[2] = "slaps <target> with the backhand of salvation.",
		},
	},
},

-------------------------------------------------------------------------------
["DRUID"] = {

	["revive"] = { -- out of combat rez
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Rezzing <target>",
			[2] = "<target>, don't go into the light, return to the land of the living!",
			[3] = "Rise, <target>, and live again!",
			[4] = "Get yer lazy bones up!",
		},
	},
	["rebirth"] = { -- battle rez
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Rezzing <target>",
			[2] = "<target>, don't go into the light, return to the land of the living!",
			[3] = "Rise, <target>, and live again!",
			[4] = "Get yer lazy bones up!",
		},
	},
},

-------------------------------------------------------------------------------
["WARLOCK"] = {

	["ritual of souls"] = { -- create soulwell
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Lock Candy! Get your lock candy here!",
			[2] = "Mmmm cookies...",
		},
	},
	["ritual of summoning"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Summoning <target> The Lazy, click to assist please",
			[2] = "If you click on the portal, someone named <target> will show up and do your job for you."
		},
	},
	["demonic soulstone"] = { -- NOTE: this is the ITEM which actually applies the soul stone
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "It's OK if we all die.  <target> has a soul stone",
			[2] = "<target> is stoned... whoa, heavy",
		},
	},
},

-------------------------------------------------------------------------------
["SHAMAN"] = {

	["ancestral spirit"] = {
		Channels = {
			BG		= "BATTLEGROUND",
			Raid	= "RAID",
			Party	= "PARTY",
			Solo	= "SAY",
		},
		WhisperTarget = true,
		Messages = {
			[1] = "Rezzing <target>",
			[2] = "<target>, don't go into the light, return to the land of the living!",
			[3] = "Rise, <target>, and live again!",
			[4] = "Get yer lazy bones up!",
		},
	},
},

-------------------------------------------------------------------------------
["DEATHKNIGHT"] = {

	["death grip"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Get over here, <target>!",
			[2] = "Hey <target>, let go of my yo-yo!",
		},
	},
	["raise dead"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "It's alive... ALIVE!!!",
			[2] = "Rise, <target>, my undead puppet, and do my bidding!",
		},
	},
},

-------------------------------------------------------------------------------
["WARRIOR"] = {

	["charge"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "CHARGE!!!",
			[2] = "Vroom Vroom!",
		},
	},
	["demoralizing shout"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "RAWR! You're sad now!",
			[2] = "You're GF likes me better! Ha!",
		},
	},
	["taunt"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Get out of my sight you english kenniggits, or I shall be forced to taunt you a second time!",
			[2] = "Your mother was a hamster and your father smelt of elderberries!",
			[3] = "You hit like a small child!",
			[4] = "You hit like a girl!",
			[5] = "The fight is over here, coward!",
		},
	}
},

-------------------------------------------------------------------------------
["ROGUE"] = {

	["vanish"] = {
		Channels = {
			BG		= nil, --"SAY",
			Raid	= nil, --"SAY",
			Party	= "SAY",
			Solo	= "SAY",
		},
		WhisperTarget = false,
		Messages = {
			[1] = "Now you see me, now you don't",
			[2] = "Where was I? Ah yes...",
		},
	},
},

-------------------------------------------------------------------------------
} -- end DEFAULT_DATA_PER_CLASS


-------------------------------------------------------------------------------
-- CHANNEL RULES
-------------------------------------------------------------------------------



local DEFAULT_CHANNEL_RULES = {
	BG		= nil, --"SAY",
	Raid	= nil, --"SAY",
	Party	= "SAY",
	Solo	= "SAY",
}


-------------------------------------------------------------------------------
-- DEBUG MESSAGES
-------------------------------------------------------------------------------


function SpeakinSpell:Print(message)
	local text = "|cff33ff99"..tostring( self ).."|r: " .. message
	DEFAULT_CHAT_FRAME:AddMessage( text )
end


function SpeakinSpell:DebugMsg(message)
	--self:Print(message) -- comment this out to suppress debug messages
end


function SpeakinSpell:DebugMsgDumpString(name, value)
	if value and type(value)=="string" then
		self:DebugMsg(name .. ":" .. value)
	end
end


function SpeakinSpell:DebugMsgDumpBool(name, value)
	if value then
		self:DebugMsg(name.."=true")
	else
		self:DebugMsg(name.."=false")
	end
end


function SpeakinSpell:DebugMsgDumpTable(Table, name)
	for k,v in pairs(Table) do
		if type(v) == "table" then
			self:DebugMsgDumpTable(v, name.."."..k)
		else
			self:DebugMsg( name.."["..k.."]".."="..tostring(v) )
		end
	end
end


-------------------------------------------------------------------------------
-- POPUP DIALOGS
-------------------------------------------------------------------------------


--[[ TODOFUTURE: get advanced new spell entry validation working for items, mounts, vanity pets, wildcards, etc
local UNKNOWN_SPELL_TEXT = "<spellname>\n\nThis does not appear to match any spell or ability that you know.\n\nIt could be an item you don't currently possess or a spell you haven't learned yet.\n\nDid you spell it correctly?"
StaticPopupDialogs["UNKNOWN_SPELL"] = {
  text = UNKNOWN_SPELL_TEXT, -- will be changed to show the spell name
  button1 = "Yes",
  button2 = "No",
  OnAccept = function() end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};
--]]

local NOT_A_NEW_SPELL_TEXT = "You already have random messages configured for the spell\n\n<spellname>"
StaticPopupDialogs["NOT_A_NEW_SPELL"] = {
  text = NOT_A_NEW_SPELL_TEXT, -- will be changed to show the spell name
  button1 = "OK",
  -- button2 = "No",
  OnAccept = function() end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};


-------------------------------------------------------------------------------
-- UTILITY FUNCTIONS
-------------------------------------------------------------------------------


-- create a deep copy of the table and return it
function SpeakinSpell:CopyTable(SourceTable)
	local dest = {} -- make a new table in 'dest'
	for k,v in pairs(SourceTable) do
		-- dig into embedded tables to copy those too, not just create references
		if type(v) == "table" then
			dest[k] = self:CopyTable(v)
		else
			dest[k] = v
		end
	end
	return dest
end


function SpeakinSpell:SelectFirstSpellIfNoneSelected()
	self:DebugMsg("SelectFirstSpellIfNoneSelected()")
	
	-- allow the current selection to remain if it is valid
	if	self.RuntimeData.CurrentSpellSelected and 
		self.RuntimeData.CurrentSpellSelected ~= "" and 
		SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected] then --NOTE: go straight to SpellTable, bypassing GetSpellTableEntry which matches wildcards
		-- the current selection is valid so keep it
		return
	end
	
	-- select the first thing in the list, if possible
	for k,v in pairs(SpeakinSpellSavedData.SpellTable) do
		self.RuntimeData.CurrentSpellSelected = k
		return
	end
	
	-- our spell list is empty
	self.RuntimeData.CurrentSpellSelected = nil
end


--[[ TODOFUTURE: get advanced validation working
function SpeakinSpell:ValidateNewSpellName(spellname)
	self:DebugMsg("ValidateNewSpellName( " ..spellname.. " )")
	-- check that the spell exists
	-- from http://www.wowwiki.com/API_GetSpellInfo
	--	Using spellId as the argument will always return the info.
	--	Using spellName or spellLink will only return the info if the spell is in your spellbook. 
	--	Otherwise it will return nil.
	if (GetSpellInfo(spellname) ~= nil) then
		return true
	end
	
	-- TODOFUTURE: validate items, mounts, and vanity pets, and wildcards
	-- tell user the spell name was mispelled
	StaticPopupDialogs["UNKNOWN_SPELL"].text = string.gsub(UNKNOWN_SPELL_TEXT, "<spellname>", spellname)
	StaticPopup_Show("UNKNOWN_SPELL");

	return false
end
-- ]]


function SpeakinSpell:DeleteSpell(spellname)
	self:DebugMsg("DeleteSpell( " ..spellname.. " )")
	
	-- delete the current selection from the SavedData and RuntimeData tables
	SpeakinSpellSavedData.SpellTable[spellname] = nil
	
	if not self.RuntimeData then
		-- we're still initializing, so the rest of this stuff doesn't matter
		return
	end
	
	self.RuntimeData.LastMessage[spellname] = nil
	self.RuntimeData.SpellList[spellname] = nil
	
	self:SelectFirstSpellIfNoneSelected() -- make sure we still have a valid spell selection
	self:ShowHideOptionsGUIControls()
end


function SpeakinSpell:CreateNewSpellMessageTable(spellname)
	self:DebugMsg("CreateNewSpellMessageTable()")
	
	spellname_lowercase = string.lower(spellname)
	-- enter the new spell into the spell tabe
	SpeakinSpellSavedData.SpellTable[spellname_lowercase] = {
		Channels = self:CopyTable(DEFAULT_CHANNEL_RULES),
		WhisperTarget = false,
		Messages = {
			[1] = "<player> is casting " .. spellname .. " on <target>",
		},
	}
	
	-- enter the new spell name into the list for the options GUI
	self.RuntimeData.SpellList[spellname_lowercase] = spellname_lowercase
end


-------------------------------------------------------------------------------
-- OPTIONS GUI FUNCTIONS
-------------------------------------------------------------------------------


function SpeakinSpell:OnClickNew()
	self:DebugMsg("OnClickNew()")
	
	-- hide everything else and show the new spell text box
	self:EnableNewSpellMode(true)
end


function SpeakinSpell:OnClickCancelNewSpell()
	self:DebugMsg("OnClickCancelNewSpell()")
	self:EnableNewSpellMode(false)
end


function SpeakinSpell:EnableNewSpellMode(enable)
	self:DebugMsg("EnableNewSpellMode()")
	-- turn on EnterNewSpellMode and update show/hide state of all options GUI controls
	self.RuntimeData.EnterNewSpellMode = enable
	self:ShowHideOptionsGUIControls()
end


function SpeakinSpell:OnSetNewSpellName(spellname)
	-- check for user cancelation by empty string
	if not spellname or spellname == "" then
		self:DebugMsg("OnSetNewSpellName() - spell name is empty - user cancelation")
		self:EnableNewSpellMode(false) -- exit "new spell" mode
		return
	end
	
	--[[ TODOFUTURE: get advanced validation working
	-- validate that it is a real spell
	-- NOTE: ValidateNewSpellName will prompt the user for apparent mispellings
	--		to authorize entries for items that aren't currently held (like demonic soulstone)
	--		or spells that aren't yet known, etc
	if not self:ValidateNewSpellName(spellname) then
		self:DebugMsg("OnSetNewSpellName() - ValidateNewSpellName returned false")
		self:EnableNewSpellMode(false) -- exit "new spell" mode
		return
	end
	--]]
	
	-- make sure the new spell name is not already in the list
	-- NOTE: bypass this... SpelltableEntry,wildcard = self:GetSpellTableEntry(spellname)
	--		go straight to SpeakinSpellSavedData.SpellTable[name]
	--		because we might be adding overriding rules for different ranks
	if SpeakinSpellSavedData.SpellTable[string.lower(spellname)] then
		-- tell user that spell is already in the list
		StaticPopupDialogs["NOT_A_NEW_SPELL"].text = string.gsub(NOT_A_NEW_SPELL_TEXT, "<spellname>", spellname)
		StaticPopup_Show("NOT_A_NEW_SPELL");
		self:DebugMsg("OnSetNewSpellName() - the spell is already in the list")
		self.RuntimeData.CurrentSpellSelected = spellname
		self:EnableNewSpellMode(false) -- exit "new spell" mode
		return
	end
	
	-- add the spell to the message table and related data structures
	self:CreateNewSpellMessageTable(spellname)
	
	-- set the spell selection to the new spell
	self.RuntimeData.CurrentSpellSelected = spellname
	
	-- exit "new spell" mode
	self:EnableNewSpellMode(false)
end


function SpeakinSpell:OnClickDelete()
	self:DebugMsg("OnClickDelete()")
	
	-- make sure we have a valid spell selection
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg("OnClickDelete() - nothing is selected to delete")
		return
	end
	
	-- delete the current selection from the SavedData table
	self:DeleteSpell(self.RuntimeData.CurrentSpellSelected)
end


function SpeakinSpell:OnGetSpellSelect()
	self:DebugMsg("OnGetSpell()")
	
	-- create a side-effect to update the shown/hidden state of all options GUI controls
	self:ShowHideOptionsGUIControls()
	
	-- return the current spell selection
	return self.RuntimeData.CurrentSpellSelected
end


function SpeakinSpell:OnSetSpellSelect(value)
	self:DebugMsg("OnSetSpell( " .. value .. " )")
	-- update the current selection
	self.RuntimeData.CurrentSpellSelected = value
end


function SpeakinSpell:OnSetChannelSelect(key, value)
	self:DebugMsg("OnSetChannelSelect( " .. value .. " )")
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg("OnSetChannelSelect() - no spell is selected")
		return
	end
	-- store the new channel selection
	if value == "Silent" then
		SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Channels[key] = nil
	else
		SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Channels[key] = value
	end
end


function SpeakinSpell:OnGetChannelSelect(key)
	self:DebugMsg("OnGetChannelSelect()")
	
	-- make sure we have a valid spell selection
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg( "OnGetChannelSelect - no spell selected" )
		-- return a default value
		if DEFAULT_CHANNEL_RULE[key] then
			return DEFAULT_CHANNEL_RULE[key]
		else
			return "Silent" -- we store nil values but show "Silent" text
		end
	end
	
	-- look up the stored settings for the channel selection rules for this spell
	local Channels = SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Channels
	if not Channels then
		self:DebugMsg( "OnGetChannelSelect - Channels table is missing, using defaults" )
		Channels = DEFAULT_CHANNEL_RULE
	end
	
	-- looks like we have a channel selection table, so return it
	if Channels[key] then
		return Channels[key]
	else
		return "Silent" -- we store nil values but show "Silent" text
	end
end


function SpeakinSpell:OnGetWhisperTarget()
	self:DebugMsg("OnGetWhisperTarget()")
	
	-- make sure we have a valid spell selection
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg( "OnGetWhisperTarget - no spell selected" )
		return false
	end
	
	-- make sure we have a spell table entry
	local SpellTableEntry = SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected]
	if not SpellTableEntry then
		self:DebugMsg( "OnGetWhisperTarget - ERROR: SpellTableEntry does not exist" )
		return false
	end
	
	-- make sure the WhisperTarget setting exists in the Spelltable
	if SpellTableEntry.WhisperTarget == nil then
		SpellTableEntry.WhisperTarget = false
	end

	-- return the WhisperTarget setting, which should be true or false
	return SpellTableEntry.WhisperTarget
end


function SpeakinSpell:OnSetWhisperTarget(value)
	self:DebugMsg("OnSetWhisperTarget( " ..tostring(value) .. " )")
	
	-- make sure we have a valid spell selection
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg( "OnSetWhisperTarget - no spell selected" )
		return
	end
	
	-- make sure we have a spell table entry
	local SpellTableEntry = SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected]
	if not SpellTableEntry then
		self:DebugMsg( "OnSetWhisperTarget - ERROR: SpellTableEntry does not exist" )
		return
	end
	
	-- store the new setting
	SpellTableEntry.WhisperTarget = value
end


function SpeakinSpell:OnGetMessage(index)
	--self:DebugMsg( "OnGetMessage( " .. index .. " )" )
	
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg( "OnGetMessage( " .. index .. " ) - no selection" )
		return ""
	end
	
	if not SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages then
		self:DebugMsg( "OnGetMessage( " .. index .. " ) - no message table for current selection: " .. self.RuntimeData.CurrentSpellSelected )
		return ""
	end
	
	local msg = SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages[index]
	if not msg then
		msg = ""
	end
	
	--self:DebugMsg( "OnGetMessage( " .. index .. " ) = " .. msg )
	return msg
end


function SpeakinSpell:OnSetMessage(index, value)
	if not value then
		value = ""
	end

	self:DebugMsg("OnSetMessage( " .. index .. "= " .. value .." )")
	
	-- make sure we have a selected spell
	if not self.RuntimeData.CurrentSpellSelected or self.RuntimeData.CurrentSpellSelected == "" then
		self:DebugMsg( "OnSetMessage( " .. index .. " ) - no selection" )
		return
	end
	
	-- make sure we have a message table for the currently selected spell
	if not SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages then
		SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages = {}
	end
	
	-- store the new value into the message table
	SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages[index] = value
	self:DebugMsg( "Message " .. index .. " for spell " .. self.RuntimeData.CurrentSpellSelected .. " set to: " .. SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages[index] )
	
	-- remove holes from the message table
	-- if the user has just deleted one of the entries, move everything else up to fill in the gap
	if value == "" then
		local Messages = SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages -- create reference for shortcut notation
		for i=index+1,MAX_MESSAGES_PER_SPELL,1 do
			Messages[i-1] = Messages[i]
		end
		Messages[MAX_MESSAGES_PER_SPELL] = nil
		-- destroy empty strings from the table
		for i=MAX_MESSAGES_PER_SPELL-1,1,-1 do
			if Messages[i] == "" then
				Messages[i] = nil
			else
				break --the rest should be valid non-empty strings
			end
		end
		-- hide the superfluous input boxes
		self:ShowHideOptionsGUIControls()
	end
end


function SpeakinSpell:OnGetShowSpellEventsToggle()
	-- if SpeakinSpellSavedData.ShowSpellEvents is nil, translate to false
	if SpeakinSpellSavedData.ShowSpellEvents then
		return true
	else
		return false
	end
end


function SpeakinSpell:OnSetShowSpellEventsToggle(value)
	SpeakinSpellSavedData.ShowSpellEvents = value
end


function SpeakinSpell:ShowHideOptionsGUIControls()
	self:DebugMsg("ShowHideOptionsGUIControls()")
	self:DebugMsgDumpTable(self.RuntimeData.SpellList, "self.RuntimeData.SpellList")
	
	-- safety check in case this function is called early
	if not self.OptionsGUI then
		self:DebugMsg("ShowHideOptionsGUIControls() - called prematurely, abort")
		return
	end
	
	-- establish some conditions that control visibility of several controls
	-- NOTE: for some unknown reason #(self.RuntimeData.SpellList) always returns 0 even if the SpellList is not empty
	local SpellListIsEmpty = true
	for k,v in pairs(self.RuntimeData.SpellList) do -- DebugMsgDumpTable works as intended, unlike #(SpellList), and it uses a for loop like this, so this should work
		SpellListIsEmpty = false
		break
	end
	local SpellListIsNonEmpty = not SpellListIsEmpty

	local EnterNewSpellMode = self.RuntimeData.EnterNewSpellMode
	local HaveSelectedSpell = (self.RuntimeData and self.RuntimeData.CurrentSpellSelected and self.RuntimeData.CurrentSpellSelected ~= "")
	
	--[[
	self:DebugMsgDumpBool("HaveSelectedSpell",	HaveSelectedSpell)
	self:DebugMsgDumpBool("SpellListIsEmpty",	SpellListIsEmpty)
	self:DebugMsgDumpBool("SpellListIsNonEmpty",SpellListIsNonEmpty)
	self:DebugMsgDumpBool("EnterNewSpellMode",	EnterNewSpellMode)
	--]]
	
	-- This table defines the condition under which each options GUI control is shown
	-- if not listed, then the control is always shown
	local ShowControlsWhen = {
		-- controls used for "new spell" mode
		["NewSpellName"]		= EnterNewSpellMode,
		["CancelNewSpellButton"]= EnterNewSpellMode,
		["NewSpellModeInstruct"]= EnterNewSpellMode,
		-- controls that are hidden for "new spell" mode
		["CaptionNormalMode"]	= (not EnterNewSpellMode),
		["ShowSpellEventsToggle"]=(not EnterNewSpellMode),
		["NewSpellButton"]		= (not EnterNewSpellMode),
		["DeleteSpellButton"]	= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["SpellSelect"]			= (not EnterNewSpellMode) and SpellListIsNonEmpty,
		["ChannelSelectCaption"]= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["ChannelSelectBG"]		= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["ChannelSelectRaid"]	= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["ChannelSelectParty"]	= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["ChannelSelectSolo"]	= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		["WhisperTargetToggle"]	= (not EnterNewSpellMode) and SpellListIsNonEmpty and HaveSelectedSpell,
		-- instructions for setup of first spell, if the spell list is empty
		["AddFirstSpellInstruct"] = SpellListIsEmpty,
	}

	-- determine how many Spell Message N input boxes are shown
	-- typically we'll show at least 1 speech message input box if we have a spell selected
	-- we want to show 1 more than the number of speeches currently configured
	-- unless we don't have a spell selected or we're in EnterNewSpell mode
	local NumSpellMessageInputsShown = 0	
	if HaveSelectedSpell and SpellListIsNonEmpty and (not EnterNewSpellMode) then
		NumSpellMessageInputsShown = 1 + #(SpeakinSpellSavedData.SpellTable[self.RuntimeData.CurrentSpellSelected].Messages)
		self:DebugMsg("NumSpellMessageInputsShown="..tostring(NumSpellMessageInputsShown))
	end
	
	-- show SpellMessageN input box if N <= NumSpellMessageInputsShown (numbering starts at 1)
	for i=1,MAX_MESSAGES_PER_SPELL,1 do
		ShowControlsWhen["SpellMessage"..i] = (i <= NumSpellMessageInputsShown)
	end

	-- toggle the shown/hidden state of all applicable controls based on the ShowControlsWhen table
	for name,show in pairs(ShowControlsWhen) do
		self.OptionsGUI.args.General.args[name].guiHidden = not show
	end
end


function SpeakinSpell:SetupOptionsGUI()
	self:DebugMsg("SetupOptionsGUI()")
	--self:DebugMsgDumpTable(self.RuntimeData.SpellList, "self.RuntimeData.SpellList")

	-- Options table for the GUI
	self.OptionsGUI = {
		type = "group",
		name = "SpeakinSpell",
		-- default = function() self:ResetToDefaults() end, -- NOTE: we can't add this here or Ace will complain - we'll add it to the frame object at the end
		args = {
			General = {
				order = 1,
				type = "group",
				name = "General Settings",
				desc = "General Settings for SpeakinSpell",
				args = {
					CaptionNormalMode = {
						order = 1,
						type = "description",
						name = "Message Settings",
					},
					ShowSpellEventsToggle = {
						order = 2,
						type = "toggle",
						width = "full",
						name = "Report detected spell events",
						desc = "You should typically leave this option disabled\n\nEnable this option to make SpeakinSpell show you (and only you) all of the spell casting events that it detects, using private addon messages that will say \"SpeakinSpell:<name of the spell SpeakinSpell sees>\".\n\nThis can be useful for figuring out the name of the spell that is cast by an item, which is typically not the name of the item itself.\n\nFor example using a [Heavy Frostweave Bandage] casts a spell called \"First Aid\" so in order to generate SpeakinSpell messages for bandages, you must enter the spell name \"First Aid\" NOT the item name \"Heavy Frostweave Bandage\"",
						get = function() return self:OnGetShowSpellEventsToggle() end,
						set = function(_, value) self:OnSetShowSpellEventsToggle(value) end,
					},
					SpellSelect = {
						order = 3,
						type = "select",
						width = "full",
						name = "Select a Spell",
						desc = "Select a spell from the list to configure random speeches for that spell.",
						values = self.RuntimeData.SpellList,
						get = function() return self:OnGetSpellSelect() end,
						set = function(_, value) self:OnSetSpellSelect(value) end,
					},
					NewSpellButton = {
						order = 4,
						type = "execute",
						name = "New",
						desc = "Add a new spell to the list",
						func = function() self:OnClickNew() end,
					},
					DeleteSpellButton = {
						order = 5,
						type = "execute",
						name = "Delete",
						desc = "Delete the selected spell from the list",
						func = function() self:OnClickDelete() end,
					},
					ChannelSelectCaption = {
						order = 6,
						type = "description",
						width= "full",
						name = "Select the channels to use when announcing this spell when...",
					},
					ChannelSelectBG = {
						order = 7,
						type = "select",
						name = "In a Battleground",
						desc = "Select which channel to speak into when announcing this spell while in a Battleground",
						values = {
							["BATTLEGROUND"]= "BATTLEGROUND",
							--["RAID"]		= "RAID",
							["PARTY"]		= "PARTY",
							["SAY"]			= "SAY",
							["EMOTE"]		= "EMOTE",
							["Silent"]		= "Silent",
						},
						get = function() return self:OnGetChannelSelect("BG") end,
						set = function(_, value) self:OnSetChannelSelect("BG",value) end,
					},
					ChannelSelectRaid = {
						order = 8,
						type = "select",
						name = "In a Raid",
						desc = "Select which channel to speak into when announcing this spell while in a Raid",
						values = {
							--["BATTLEGROUND"]= "BATTLEGROUND",
							["RAID"]		= "RAID",
							["PARTY"]		= "PARTY",
							["SAY"]			= "SAY",
							["EMOTE"]		= "EMOTE",
							["Silent"]		= "Silent",
						},
						get = function() return self:OnGetChannelSelect("Raid") end,
						set = function(_, value) self:OnSetChannelSelect("Raid",value) end,
					},
					ChannelSelectParty = {
						order = 9,
						type = "select",
						name = "In a Party",
						desc = "Select which channel to speak into when announcing this spell while in a Party",
						values = {
							--["BATTLEGROUND"]= "BATTLEGROUND",
							--["RAID"]		= "RAID",
							["PARTY"]		= "PARTY",
							["SAY"]			= "SAY",
							["EMOTE"]		= "EMOTE",
							["Silent"]		= "Silent",
						},
						get = function() return self:OnGetChannelSelect("Party") end,
						set = function(_, value) self:OnSetChannelSelect("Party",value) end,
					},
					ChannelSelectSolo = {
						order = 10,
						type = "select",
						name = "By yourself",
						desc = "Select which channel to speak into when announcing this spell while playing solo",
						values = {
							--["BATTLEGROUND"]= "BATTLEGROUND",
							--["RAID"]		= "RAID",
							--["PARTY"]		= "PARTY",
							["SAY"]			= "SAY",
							["EMOTE"]		= "EMOTE",
							["Silent"]		= "Silent",
						},
						get = function() return self:OnGetChannelSelect("Solo") end,
						set = function(_, value) self:OnSetChannelSelect("Solo",value) end,
					},
					WhisperTargetToggle = {
						order = 11,
						type = "toggle",
						width = "full",
						name = "Whisper the message to your target",
						desc = "Enable whispering your spell announcement message to the target of your spell.\n\nOnly applies to spells cast with a valid friendly target, otherwise this option will be ignored.",
						get = function() return self:OnGetWhisperTarget() end,
						set = function(_, value) self:OnSetWhisperTarget(value) end,
					},
					-- special hidden text box for entering new spell names
					-- this is only shown after the user clicks on NEW
					NewSpellModeInstruct = {
						order = 1,
						type = "description",
						name = "Enter the name of a spell that you want to trigger random speeches\n\nThe name of the spell must be spelled exactly right, but is not case sensitive.\n\nSpecifying the rank is optional, but can be useful if you want to announce casting of a down-ranked spell differently from any other rank of that spell.\n\nThe following examples are all valid\nPolymorph\npolymorph\nPolymorph (Rank 2)\npolymorph (Rank 2)",
						guiHidden = true, --by default, until OnClickNew is called
					},
					NewSpellName = {
						order = 2,
						width = "full",
						type = "input",
						name = "Enter a new Spell Name",
						desc = "Enter the name of a spell that you want to trigger random speeches\n\nThe name of the spell must be spelled exactly right, but is not case sensitive.\n\nSpecifying the rank is optional, but can be useful if you want to announce casting of a down-ranked spell differently from any other rank of that spell.\n\nThe following examples are all valid\nPolymorph\npolymorph\nPolymorph (Rank 2)\npolymorph (Rank 2)",
						get = function() return "" end,
						set = function(_, value) self:OnSetNewSpellName(value) end,
						guiHidden = true, --by default, until OnClickNew is called
					},
					CancelNewSpellButton = {
						order = 3,
						type = "execute",
						name = "Cancel New Spell",
						desc = "Cancel entering the new spell and return to the previous interface.",
						func = function() self:OnClickCancelNewSpell() end,
						guiHidden = true, --by default, until OnClickNew is called
					},
					-- instructions will be shown to add a new spell if the list is empty
					AddFirstSpellInstruct = {
						order = 1,
						type = "description",
						name = "You do not have any spells or abilities configured for this character\n\nClick New to get started",
						guiHidden = true, --by default, until OnClickNew is called
					},
					-- a list of up to 10 (MAX_MESSAGES_PER_SPELL) input boxes will be added by a loop below
					-- for entering/editing the random speeches for each spell
				}, --end args
			}, --end General
		}, --end args
	} -- end options
	
	-- add MAX_MESSAGES_PER_SPELL random speech input boxes
	for i=1,MAX_MESSAGES_PER_SPELL,1 do
		self.OptionsGUI.args.General.args["SpellMessage"..i] = {
			order = i + 11, -- should be the order of the last item listed above the message input boxes, plus i
			width = "full",
			type = "input",
			name = "Random Speech "..i,
			desc = "One of the random speeches associated with the selected spell",
			get = function() return self:OnGetMessage(i) end,
			set = function(_, value) self:OnSetMessage(i, value) end,
			guiHidden = true, --by default, until ShowHideOptionsGUIControls is called
		}
	end
	
	-- add the options to the in-game interface options panel at Escape > Interface > Addons > SpeakinSpell
	-- The ordering here matters, it determines the order in the Blizzard Interface Options
	-- (or it would matter if we had sub-categories, which we currently don't)
	-- InterfaceOptions_AddCategory(self.OptionsGUI) -- done via Ace below

	LibStub("AceConfig-3.0"):RegisterOptionsTable("SpeakinSpell", self.OptionsGUI, nil)
	self.optionsFrames = {["General"] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SpeakinSpell", nil, nil, "General")}
	
	-- AddToBlizOptions returns the frame object.  Add a default button handler
	self.optionsFrames.General.default = function() self:ResetToDefaults() end
end



-------------------------------------------------------------------------------
-- GENERAL INITIALIZATION
-------------------------------------------------------------------------------


-- our saved data is stored in SpeakinSpellSavedData.SpellTable
-- we must declare the parent table SpeakinSpellSavedData
-- but we know whether real data has been loaded or not if SpeakinSpellSavedData.SpellTable exists
-- NOTE: SpeakinSpellSavedData.SpellTable may be an empty table
SpeakinSpellSavedData = {}

function SpeakinSpell:InitDefaultSavedData()
	self:DebugMsg("InitDefaultSavedData()")
	
	-- copy defaults into current settings using class-specific defaults
	local playerClass, englishClass = UnitClass("player"); --englishClass is the UPPERCASE class name in English
	local DefaultData = DEFAULT_DATA_PER_CLASS[englishClass]
	SpeakinSpellSavedData.SpellTable = self:CopyTable(DefaultData)

	--self:DebugMsgDumpTable(SpeakinSpellSavedData.SpellTable, "SpeakinSpellSavedData.SpellTable")
	--self:DeleteInvalidSpells() -- we can't let this happen too soon during loading, or it will think all spells are invalid
	--self:DebugMsgDumpTable(SpeakinSpellSavedData.SpellTable, "SpeakinSpellSavedData.SpellTable")
end


function SpeakinSpell:ResetToDefaults()
	self:DebugMsg("ResetToDefaults()")
	
	-- copy defaults into current settings using class-specific defaults
	local playerClass, englishClass = UnitClass("player"); --englishClass is the UPPERCASE class name in English
	local DefaultData = DEFAULT_DATA_PER_CLASS[englishClass]
	SpeakinSpellSavedData.SpellTable = self:CopyTable(DefaultData)
	SpeakinSpellSavedData.ShowSpellEvents = false
	
	self:InitRuntimeData()
	self:ShowHideOptionsGUIControls() -- this might be redundant but doesn't seem to hurt
	
	-- if the options GUI is showing right now, we need to refresh it to make it show the new data
	-- the only way I found to do this is to hide and then show the frame
	if self.optionsFrames and self.optionsFrames.General and self.optionsFrames.General:IsVisible() then
		self.optionsFrames.General:Hide()
		self.optionsFrames.General:Show()
	end
	
	self:Print("Default settings restored")
end


function SpeakinSpell:InitRuntimeData()
	self:DebugMsg("InitRuntimeData()")
	
	-- this is just a declaration
	self.RuntimeData = {
		CurrentSpellSelect = nil,	-- current spell selected in the options GUI
		SpellList = {},				-- complete list of spells displayed in the options GUI
		LastMessage = {},			-- just an empty table for now, this will be [spellname] = "last random speech triggered by this spell" to prevent repeats
		EnterNewSpellMode = false,	-- flag indicating that the user is entering a new spell for the list
	}
	
	for spellname,info in pairs(SpeakinSpellSavedData.SpellTable) do
		-- build the spell list for use by the options GUI
		self.RuntimeData.SpellList[spellname] = spellname
		self:DebugMsg("InitRuntimeData: added spell: " .. spellname)
		-- make sure we have a current spell selected for the options GUI
		if not self.RuntimeData.CurrentSpellSelected then
			self.RuntimeData.CurrentSpellSelected = spellname
		end
	end
	
	--self:DebugMsgDumpTable(self.RuntimeData.SpellList, "self.RuntimeData.SpellList", "")

	-- the options GUI may still have a reference to the old SavedData table.
	-- refresh it since we've rebuilt the table
	-- but if we're initializing then the OptionsGUI may not have been created yet
	if self.OptionsGUI then
		self.OptionsGUI.args.General.args.SpellSelect.values = self.RuntimeData.SpellList
	end
end


function SpeakinSpell:OnInitialize()
	self:DebugMsg("OnInitialize()")
    -- Called when the addon is loaded

	self:RegisterAllEvents()
	self:RegisterChatCommands()	-- register chat commands
	-- the rest of the initialization does not occur until VARIABLES_LOADED
	
	-- done loading
    self:Print("Loaded")
end


-------------------------------------------------------------------------------
-- EVENT HANDLERS
-------------------------------------------------------------------------------


function SpeakinSpell:VARIABLES_LOADED()
	self:DebugMsg("VARIABLES_LOADED()")
	
	-- SpeakinSpellSavedData will always exist
	-- SpeakinSpellSavedData.SpellTable only exists if actual data has been loaded
	-- NOTE: SpeakinSpellSavedData.SpellTable may be empty, but its parent table SpeakinSpellSavedData never will be
	if not SpeakinSpellSavedData.SpellTable then
		self:DebugMsg("VARIABLES_LOADED() - SpeakinSpellSavedData.SpellTable does not exist, using defaults")
		-- new user: load defaults
		self:InitDefaultSavedData()
	end
	self:DebugMsgDumpTable(SpeakinSpellSavedData.SpellTable, "SpeakinSpellSavedData.SpellTable")

	-- set up runtime data that we don't save, only after the saved variables are loaded
	self:InitRuntimeData()
	
	-- set up the Options GUI config - we need the Runtime Data before we can do this
	self:SetupOptionsGUI()
end


function SpeakinSpell:SPELL_AURA_APPLIED(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType)
	-- we're only concerned with buffs
	if auraType ~= "BUFF" then return end
	-- we're only concerned with buffs we cast on ourselves
	if dstName ~= srcName then return end
	if srcName ~= UnitName("player") then return end
	-- ignore redundant events that are also applied by the last UNIT_SPELLCAST_SENT event
	if spellName == self.RuntimeData.Last_UNIT_SPELLCAST_SENT then return end
	
	-- process the spell
	-- this function is shared with the UNIT_SPELLCAST_SENT event handler
	self:OnValidSpellcastDetected(spellName, "")
end


function SpeakinSpell:COMBAT_LOG_EVENT_UNFILTERED(_,timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	--self:Print("COMBAT_LOG_EVENT_UNFILTERED: "..eventtype)
	if eventtype == "SPELL_AURA_APPLIED" then
		self:SPELL_AURA_APPLIED(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	end
end


function SpeakinSpell:UNIT_SPELLCAST_SENT(event, caster, name, rank, target)
	self:DebugMsg("UNIT_SPELLCAST_SENT()")
	
	self:DebugMsgDumpString("event",	event)
	self:DebugMsgDumpString("caster",	caster)
	self:DebugMsgDumpString("name",		name)
	self:DebugMsgDumpString("rank",		rank)
	self:DebugMsgDumpString("target",	target)
	
	-- only speak for spells cast by the player, not anyone else
	if caster ~= "player" then
		self:DebugMsg("UNIT_SPELLCAST_SENT - do not speak for spells cast by: " .. caster)
		return
	end
	
	-- prevent SPELL_AURA_APPLIED from triggering a redundant event for a matching aura cast by this spell
	self.RuntimeData.Last_UNIT_SPELLCAST_SENT = name
	
	-- process the spell
	-- this function is shared with the SPELL_AURA_APPLIED event handler
	self:OnValidSpellcastDetected(name, rank)
end


function SpeakinSpell:OnValidSpellcastDetected(name, rank)
	self:DebugMsg("OnValidSpellcastDetected()")
	
	if SpeakinSpellSavedData.ShowSpellEvents then
		if rank ~= "" then
			self:Print(name.." ("..rank..")")
		else
			self:Print(name)
		end
	end
	
	name = string.lower(name) -- force to lowercase for case-insensitive string matching
	rank = string.lower(rank) -- force to lowercase for case-insensitive string matching
	
	local SpellTableEntry,wildcard = self:GetSpellTableEntry(name, rank)
	if not SpellTableEntry then
		self:DebugMsg("OnValidSpellcastDetected - no messages configured for: " .. name)
		return
	end
	
	-- speak a random message
	self:SpeakForSpell(SpellTableEntry, name, target, wildcard)
end


function SpeakinSpell:RegisterAllEvents()
	self:DebugMsg("RegisterAllEvents()")
	-- register for spellcasting events
	-- which is our hook too know when to speak for a spell
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("VARIABLES_LOADED")
end


function SpeakinSpell:OnEnable()
	self:DebugMsg("OnEnable()")
	-- Called when the addon is enabled
	-- self:RegisterAllEvents() -- did this OnInitialize
	self:ShowHideOptionsGUIControls() -- make sure the options GUI is setup correctly
end


function SpeakinSpell:OnDisable()
	self:DebugMsg("OnDisable()")
    -- Called when the addon is disabled
	-- we don't need to do anything here
end


-------------------------------------------------------------------------------
-- SLASH COMMAND HANDLERS
-------------------------------------------------------------------------------


function SpeakinSpell:RegisterChatCommands()
	self:DebugMsg("RegisterChatCommands()")
	
	self:RegisterChatCommand("SpeakinSpell","OnSlashCommand")
	self:RegisterChatCommand("speakinspell","OnSlashCommand")
	self:RegisterChatCommand("ss",			"OnSlashCommand")
	self:RegisterChatCommand("SS",			"OnSlashCommand")
end


function SpeakinSpell:OnSlashCommand(input)
	self:DebugMsg("OnSlashCommand()")
	self:DebugMsgDumpString("input", input)

	-- Process the slash command ('input' contains whatever follows the slash command)
	-- /ss			- show options
	-- /ss options	- also show options
	-- /ss reset	- reset to defaults
	if (not input or input == "" or input == "options") then
		self:ShowOptions()
	elseif (input == "reset") then
		self:ResetToDefaults()
	else
		self:Print("Usage Info for /SpeakinSpell (/ss)")
		self:Print("/ss         - show options")
		self:Print("/ss options - show options")
		self:Print("/ss reset   - reset to defaults")
	end
end


function SpeakinSpell:ShowOptions()
	self:DebugMsg("ShowOptions()")
	--self:DebugMsgDumpTable(self.RuntimeData.SpellList, "self.RuntimeData.SpellList", "")

	-- this is probably not necessary, but make sure this is up to date before opening the options panel
	self:ShowHideOptionsGUIControls()
	
	-- open interface options to show SpeakinSpell
	InterfaceOptionsFrame_OpenToCategory("SpeakinSpell")
end


-------------------------------------------------------------------------------
-- RANDOM SPEECHES - THE CORE FUNCTIONALITY
-------------------------------------------------------------------------------


-- returns SpellTableEntry, wildcard
function SpeakinSpell:GetSpellTableEntry(name, rank)
	-- check for an entry for the name with rank
	local SpellTableEntry = SpeakinSpellSavedData.SpellTable[ name .. " (" .. rank .. ")" ]
	if SpellTableEntry then
		return SpellTableEntry, ""
	end
	
	-- try the name only
	SpellTableEntry = SpeakinSpellSavedData.SpellTable[ name ]
	if SpellTableEntry then
		return SpellTableEntry, ""
	end
	
	-- TODOFUTURE: match wildcards, for example "portal: *"
	
	-- no spell table entry defined for this name and rank
	return nil, ""
end
	
	
function SpeakinSpell:SelectRandomMessage(spellname, SpellTableEntry)
	self:DebugMsg("SelectRandomMessage( "..spellname.." )")
	assert(SpellTableEntry and SpellTableEntry.Messages) -- this function should not be called unless we have a valid table for this spell
	
	-- select a random message from the user-specific table
	
	local sizelist = #(SpellTableEntry.Messages)
	local tempnum = math.random(1, sizelist);
	
	msg = SpellTableEntry.Messages[tempnum]
	assert(msg)
	assert(type(msg) == "string")
	
	-- avoid repeating the same message we used last time
	-- unless there's only one in the list
	while sizelist > 1 and msg == self.RuntimeData.LastMessage[spellname] do
		tempnum = math.random(1, sizelist);
		msg = SpellTableEntry.Messages[tempnum]
	end
	
	-- remember we selected this, so we don't repeat it next time
	self.RuntimeData.LastMessage[spellname] = msg
	
	return msg
end


function SpeakinSpell:GetChatChannelForSpell(SpellTableEntry)
	self:DebugMsg("GetChatChannelForSpell()")

	if (GetNumBattlefieldScores() > 0) then
		return SpellTableEntry.Channels.BG
	elseif (GetNumRaidMembers() > 0) then
		return SpellTableEntry.Channels.Raid
	elseif (GetNumPartyMembers() > 0) then
		return SpellTableEntry.Channels.Party
	else -- solo
		return SpellTableEntry.Channels.Solo
	end
end


function SpeakinSpell:SpeakForSpell(SpellTableEntry, spellname, target, wildcard)
	-- determine which channel we will speak in
	channel = self:GetChatChannelForSpell(SpellTableEntry)
	local WhisperTarget = SpellTableEntry.WhisperTarget and target and (target ~= "") and (target ~= "Unknown") and (target ~= UnitName("player")) and UnitIsFriend("player","target")
	if not channel and not WhisperTarget then
		-- this spell's speaches have been silenced for the current situation
		return
	end
	
	msg = self:SelectRandomMessage(spellname, SpellTableEntry)
	
	if not target or target == "" or target == "Unknown" then
		target = "<no target>"
	end
	
	local Substitutions = {
		["<player>"]	= UnitName("player"),	-- the player's name
		["<target>"]	= target,				-- the target's name (safety check for NULL below)
		--["<wildcard>"]	= wildcard, -- the wildcard that was matched to this spell -- TODOFUTURE: add support for wildcards
		["<TM>"]		= "™",	-- an auto-substitution like MS Word would use
		["<R>"]			= "®",	-- an auto-substitution like MS Word would use
	}
	
	-- insert variable values into the message text
	for key,value in pairs(Substitutions) do
		msg = string.gsub(msg, key, value);
	end
	
	-- say the message to the chat, if applicable
	if channel then
		SendChatMessage(msg, channel);
	end
	
	-- send the message to a whisper to the target, if applicable
	if WhisperTarget then
		SendChatMessage(msg, "WHISPER", nil, target);
	end
end


